Index: /branches/dev_r1821_mixed_ldfdyn/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/CONFIG/GYRE/EXP00/namelist	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/CONFIG/GYRE/EXP00/namelist	(revision 2182)
@@ -478,6 +478,7 @@
    ln_dynldf_iso    =  .false.  !  iso-neutral                          (require "key_ldfslp")
                            !  Coefficient
-   rn_ahm_0    = 100000.        !  horizontal eddy viscosity   [m2/s]
-   rn_ahmb_0   =     0.         !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_lap     = 100000.   !  horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahmb_0        =     0.    !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_blp     =     0.    !  horizontal bilaplacian eddy viscosity [m4/s]
 /
 !!======================================================================
Index: /branches/dev_r1821_mixed_ldfdyn/CONFIG/GYRE_LOBSTER/EXP00/namelist
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/CONFIG/GYRE_LOBSTER/EXP00/namelist	(revision 2182)
@@ -478,6 +478,7 @@
    ln_dynldf_iso    =  .false.  !  iso-neutral                          (require "key_ldfslp")
                            !  Coefficient
-   rn_ahm_0    = 100000.        !  horizontal eddy viscosity   [m2/s]
-   rn_ahmb_0   =     0.         !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0         = 100000.   !  horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahmb_0        =     0.    !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_blp     =     0.    !  horizontal bilaplacian eddy viscosity [m4/s]
 /
 !!======================================================================
Index: /branches/dev_r1821_mixed_ldfdyn/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 2182)
@@ -505,5 +505,5 @@
    ln_dynldf_iso    =  .false.  !  iso-neutral                          (require "key_ldfslp")
                            !  Coefficient
-   rn_ahm_0         = 40000.    !  horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahm_0_lap     = 40000.    !  horizontal laplacian eddy viscosity   [m2/s]
    rn_ahmb_0        =     0.    !  background eddy viscosity for ldf_iso [m2/s]
    rn_ahm_0_blp     =     0.    !  horizontal bilaplacian eddy viscosity [m4/s] 
Index: /branches/dev_r1821_mixed_ldfdyn/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/CONFIG/ORCA2_LIM_PISCES/EXP00/namelist	(revision 2182)
@@ -505,6 +505,7 @@
    ln_dynldf_iso    =  .false.  !  iso-neutral                          (require "key_ldfslp")
                            !  Coefficient
-   rn_ahm_0    = 40000.         !  horizontal eddy viscosity   [m2/s]
-   rn_ahmb_0   =     0.         !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_lap     = 40000.    !  horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahmb_0        =     0.    !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_blp     =     0.    !  horizontal bilaplacian eddy viscosity [m4/s]
 /
 !!======================================================================
Index: /branches/dev_r1821_mixed_ldfdyn/CONFIG/POMME/EXP00/namelist
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/CONFIG/POMME/EXP00/namelist	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/CONFIG/POMME/EXP00/namelist	(revision 2182)
@@ -502,6 +502,7 @@
    ln_dynldf_iso    =  .false.  !  iso-neutral                          (require "key_ldfslp")
                            !  Coefficient
-   rn_ahm_0    = -1.5e11        !  horizontal eddy viscosity   [m2/s]
-   rn_ahmb_0   =    500.        !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_lap     =     0.    !  horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahmb_0        =    500.   !  background eddy viscosity for ldf_iso [m2/s]
+   rn_ahm_0_blp     = -1.5e11   !  horizontal bilaplacian eddy viscosity [m4/s]
 /
 !!======================================================================
Index: /branches/dev_r1821_mixed_ldfdyn/DOC/TexFiles/Namelist/nam_dynldf
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/DOC/TexFiles/Namelist/nam_dynldf	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/DOC/TexFiles/Namelist/nam_dynldf	(revision 2182)
@@ -10,5 +10,5 @@
    ln_dynldf_iso    =  .false.  !     iso-neutral                      (require "key_ldfslp")
                                 !  Coefficient
-   rn_ahm_0         = 40000.    !     horizontal laplacian eddy viscosity   [m2/s]
+   rn_ahm_0_lap     = 40000.    !     horizontal laplacian eddy viscosity   [m2/s]
    rn_ahmb_0        =     0.    !     background eddy viscosity for ldf_iso [m2/s]
    rn_ahm_0_blp     =     0.    !     horizontal bilaplacian eddy viscosity [m4/s] 
Index: /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 2182)
@@ -32,5 +32,5 @@
    PUBLIC   dyn_ldf   ! called by step module 
 
-   INTEGER ::   nldf = 0   ! type of lateral diffusion used defined from ln_dynldf_... namlist logicals)
+   INTEGER ::   nldf = -2   ! type of lateral diffusion used defined from ln_dynldf_... namlist logicals)
 
    !! * Substitutions
Index: /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 2182)
@@ -67,5 +67,5 @@
       NAMELIST/namdyn_ldf/ ln_dynldf_lap  , ln_dynldf_bilap,                  &
          &                 ln_dynldf_level, ln_dynldf_hor  , ln_dynldf_iso,   &
-         &                 rn_ahm_0       , rn_ahmb_0      , rn_ahm_0_blp
+         &                 rn_ahm_0_lap   , rn_ahmb_0      , rn_ahm_0_blp
       !!----------------------------------------------------------------------
 
@@ -83,11 +83,11 @@
          WRITE(numout,*) '      horizontal (geopotential)               ln_dynldf_hor   = ', ln_dynldf_hor
          WRITE(numout,*) '      iso-neutral                             ln_dynldf_iso   = ', ln_dynldf_iso
-         WRITE(numout,*) '      horizontal laplacian eddy viscosity     rn_ahm_0        = ', rn_ahm_0
+         WRITE(numout,*) '      horizontal laplacian eddy viscosity     rn_ahm_0_lap    = ', rn_ahm_0_lap
          WRITE(numout,*) '      background viscosity                    rn_ahmb_0       = ', rn_ahmb_0
-         WRITE(numout,*) '      horizontal bilaplacian eddy viscosity   rn_ahm_0        = ', rn_ahm_0
-
-      ENDIF
-
-      ahm0     = rn_ahm_0                  ! OLD namelist variables defined from DOCTOR namelist variables
+         WRITE(numout,*) '      horizontal bilaplacian eddy viscosity   rn_ahm_0_blp    = ', rn_ahm_0_blp
+
+      ENDIF
+
+      ahm0     = rn_ahm_0_lap              ! OLD namelist variables defined from DOCTOR namelist variables
       ahmb0    = rn_ahmb_0
       ahm0_blp = rn_ahm_0_blp
@@ -120,5 +120,4 @@
       IF( ln_dynldf_bilap ) THEN
          IF(lwp) WRITE(numout,*) '   biharmonic momentum diffusion'
-         IF( ahm0_blp == 0.0 ) ahm0_blp = ahm0       ! Old namelist method: bilap specified with ahm0
          IF( .NOT. ln_dynldf_lap ) ahm0 = ahm0_blp   ! Allow spatially varying coefs, which use ahm0 as input
          IF( ahm0_blp > 0 .AND. .NOT. lk_esopa )   CALL ctl_stop( 'The horizontal viscosity coef. ahm0 must be negative' )
Index: /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90
===================================================================
--- /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 2181)
+++ /branches/dev_r1821_mixed_ldfdyn/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 2182)
@@ -17,9 +17,9 @@
    LOGICAL , PUBLIC ::   ln_dynldf_hor   = .TRUE.      !: horizontal (geopotential) direction
    LOGICAL , PUBLIC ::   ln_dynldf_iso   = .FALSE.     !: iso-neutral direction
-   REAL(wp), PUBLIC ::   rn_ahm_0        = 40000._wp   !: lateral laplacian eddy viscosity (m2/s)
+   REAL(wp), PUBLIC ::   rn_ahm_0_lap    = 40000._wp   !: lateral laplacian eddy viscosity (m2/s)
    REAL(wp), PUBLIC ::   rn_ahmb_0       =     0._wp   !: lateral laplacian background eddy viscosity (m2/s)
    REAL(wp), PUBLIC ::   rn_ahm_0_blp    =     0._wp   !: lateral bilaplacian eddy viscosity (m4/s)
 
-   REAL(wp), PUBLIC ::   ahm0, ahmb0, ahm0_blp       ! OLD namelist names
+   REAL(wp), PUBLIC ::   ahm0, ahmb0, ahm0_blp         ! OLD namelist names
 
 #if defined key_dynldf_c3d