Index: /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_DYN.tex
===================================================================
--- /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_DYN.tex	(revision 2222)
+++ /branches/DEV_r1826_DOC/DOC/TexFiles/Chapters/Chap_DYN.tex	(revision 2223)
@@ -11,9 +11,9 @@
 $\ $\newline      %force an empty line
 
-Using the representation described in Chap.\ref{DOM}, several semi-discrete 
+Using the representation described in Chapter \ref{DOM}, several semi-discrete 
 space forms of the dynamical equations are available depending on the vertical 
 coordinate used and on the conservation properties of the vorticity term. In all 
 the equations presented here, the masking has been omitted for simplicity. 
-One must be aware that all the quantities are masked fields and that each time a 
+One must be aware that all the quantities are masked fields and that each time an
 average or difference operator is used, the resulting field is multiplied by a mask.
 
@@ -25,7 +25,7 @@
 \end{equation*}
 NXT stands for next, referring to the time-stepping. The first group of terms on 
-the rhs of the momentum equations corresponds to the Coriolis and advection 
+the rhs of the this equation corresponds to the Coriolis and advection 
 terms that are decomposed into a vorticity part (VOR), a kinetic energy part (KEG) 
-and, a vertical advection part (ZAD) in the vector invariant formulation or a Coriolis 
+and, either a vertical advection part (ZAD) in the vector invariant formulation, or a Coriolis 
 and advection part (COR+ADV) in the flux formulation. The terms following these 
 are the pressure gradient contributions (HPG, Hydrostatic Pressure Gradient, 
@@ -39,9 +39,9 @@
 
 In the present chapter we also describe the diagnostic equations used to compute 
-the horizontal divergence and curl of the velocities (\emph{divcur} module) as well 
-as the vertical velocity (\emph{wzvmod} module).
+the horizontal divergence, curl of the velocities (\emph{divcur} module) and 
+the vertical velocity (\emph{wzvmod} module).
 
 The different options available to the user are managed by namelist variables. 
-For equation term \textit{ttt}, the logical namelist variables are \textit{ln\_dynttt\_xxx}, 
+For term \textit{ttt} in the momentum equations, the logical namelist variables are \textit{ln\_dynttt\_xxx}, 
 where \textit{xxx} is a 3 or 4 letter acronym corresponding to each optional scheme. 
 If a CPP key is used for this term its name is \textbf{key\_ttt}. The corresponding 
@@ -49,8 +49,8 @@
 usually computed in the \textit{dyn\_ttt\_xxx} subroutine.
 
-The user has the option of extracting each tendency term of both the rhs of the 
-3D momentum equation (\key{trddyn} defined) for output, as described in 
-Chap.\ref{MISC}.  Furthermore, the tendency terms associated to the 2D 
-barotropic vorticity balance (\key{trdvor} defined) can be derived on-line from the 
+The user has the option of extracting and outputting each tendency term from the
+3D momentum equations (\key{trddyn} defined), as described in 
+Chap.\ref{MISC}.  Furthermore, the tendency terms associated with the 2D 
+barotropic vorticity balance (when \key{trdvor} is defined) can be derived from the 
 3D terms.
 %%%
@@ -86,11 +86,11 @@
 \end{equation} 
 
-Note that in the $z$-coordinate with full step (\key{zco} is defined), 
-$e_{3u}$=$e_{3v}$=$e_{3f}$ so that they cancel in \eqref{Eq_divcur_div}.
-
-Note also that whereas the vorticity have the same discrete expression in $z$- 
-and $s$-coordinate, its physical meaning is not identical. $\zeta$ is a pseudo 
+Note that in the $z$-coordinate with full step (when \key{zco} is defined), 
+$e_{3u}$=$e_{3v}$=$e_{3f}$ so that these metric terms cancel in \eqref{Eq_divcur_div}.
+
+Note also that although the vorticity has the same discrete expression in $z$- 
+and $s$-coordinates, its physical meaning is not identical. $\zeta$ is a pseudo 
 vorticity along $s$-surfaces (only pseudo because $(u,v)$ are still defined along 
-geopotential surfaces, but are no more necessary defined at the same depth).
+geopotential surfaces, but are not necessarily defined at the same depth).
 
 The vorticity and divergence at the \textit{before} step are used in the computation 
@@ -121,29 +121,30 @@
 where \textit{emp} is the surface freshwater budget (evaporation minus precipitation), 
 expressed in Kg/m$^2$/s (which is equal to mm/s), and $\rho _w$=1,000~Kg/m$^3$ 
-is the volumic mass of pure water. If river runoff is expressed as a surface freshwater 
+is the density of pure water. If river runoff is expressed as a surface freshwater 
 flux (see \S\ref{SBC}) then \textit{emp} can be written as the evaporation minus 
 precipitation, minus the river runoff. The sea-surface height is evaluated 
-using exactly the same time stepping as the tracer equation \eqref{Eq_tra_nxt}: 
+using exactly the same time stepping scheme as the tracer equation \eqref{Eq_tra_nxt}: 
 a leapfrog scheme in combination with an Asselin time filter, $i.e.$ the velocity appearing 
 in \eqref{Eq_dynspg_ssh} is centred in time (\textit{now} velocity). 
-This is of paramount importance. Substituing $T$ by $1$ in the tracer equation and summing
+This is of paramount importance. Replacing $T$ by the number $1$ in the tracer equation and summing
 over the water column must lead to the sea surface height equation otherwise tracer content
-could not be conserved \ref{Griffies_al_MWR01, LeclairMadec2009}.
+will not be conserved \ref{Griffies_al_MWR01, LeclairMadec2009}.
 
 The vertical velocity is computed by an upward integration of the horizontal 
-divergence from the bottom, taken into account the change of the thickness of the levels :
+divergence starting at the bottom, taking into account the change of the thickness of the levels :
 
 \begin{equation} \label{Eq_wzv}
 \left\{   \begin{aligned}
 &\left. w \right|_{3/2} \quad= 0   	\\
-&\left. w \right|_{k+1/2}     = \left. w \right|_{k+1/2}  + e_{3t}\;  \left. \chi \right|_k  
+&\left. w \right|_{k+1/2}     = \left. w \right|_{k-1/2}  + e_{3t}\;  \left. \chi \right|_k  
                                          - \frac{ e_{3t}^{t+1} - e_{3t}^{t-1} } {2 \rdt}
 \end{aligned}   \right.
 \end{equation}
-
-In case of a non-linear free surface (\key{vvl}), the top vertical velocity is $-\textit{emp}/\rho_w$, 
-as changes in the the divergence of the barotropic transport is absorbed in the change 
-of the levels thickness.re-oriented downward co
-In case of linear free surface, the time derivative in \eqref{Eq_wzv} cancel out.
+\sgacomment{should e3t involve k in this equation?}
+
+In the case of a non-linear free surface (\key{vvl}), the top vertical velocity is $-\textit{emp}/\rho_w$, 
+as changes in the divergence of the barotropic transport are absorbed into the change 
+of the level thicknesses, re-orientated downward.
+In the case of a linear free surface, the time derivative in \eqref{Eq_wzv} disappears.
 The upper boundary condition applies at a fixed level $z=0$. The top vertical velocity 
 is thus equal to the divergence of the barotropic transport ($i.e.$ the first term in the
@@ -151,7 +152,7 @@
 
 Note also that whereas the vertical velocity has the same discrete 
-expression in $z$- and $s$-coordinate, its physical meaning is not the same: 
+expression in $z$- and $s$-coordinates, its physical meaning is not the same: 
 in the second case, $w$ is the velocity normal to the $s$-surfaces. 
-Note also that the $k$-axis is re-oriented downward in the \textsc{fortran} code compare 
+Note also that the $k$-axis is re-orientated downwards in the \textsc{fortran} code compared 
 to the indexing used in the semi-discrete equations such as \eqref{Eq_wzv} 
 (see  \S\ref{DOM_Num_Index_vertical}). 
@@ -168,6 +169,6 @@
 
 The vector invariant form of the momentum equations is the one most 
-often used in applications of \NEMO ocean model. The flux form option 
-(see next section) has been introduced since version $2$. 
+often used in applications of the \NEMO ocean model. The flux form option 
+(see next section) has been present since version $2$. 
 Coriolis and momentum advection terms are evaluated using a leapfrog 
 scheme, $i.e.$ the velocity appearing in these expressions is centred in 
@@ -194,5 +195,5 @@
 The vorticity terms are given below for the general case, but note that in the full step 
 $z$-coordinate (\key{zco} is defined), $e_{3u}$=$e_{3v}$=$e_{3f}$ so that the vertical scale 
-factors disappear. They are all computed in dedicated routines that can be found in 
+factors disappear. The vorticity terms are all computed in dedicated routines that can be found in 
 the \mdl{dynvor} module.
 
@@ -241,7 +242,7 @@
 \label{DYN_vor_mix}
 
-The mixed energy/enstrophy conserving scheme (MIX scheme), a mixture of the 
+For the mixed energy/enstrophy conserving scheme (MIX scheme), a mixture of the 
 two previous schemes is used. It consists of the ENS scheme (\ref{Eq_dynvor_ens}) 
-to the relative vorticity term, and of the ENE scheme (\ref{Eq_dynvor_ene}) applied 
+for the relative vorticity term, and of the ENE scheme (\ref{Eq_dynvor_ene}) applied 
 to the planetary vorticity term.
 \begin{equation} \label{Eq_dynvor_mix}
@@ -267,23 +268,22 @@
 averages of the velocity allows for the presence of grid point oscillation structures 
 that will be invisible to the operator. These structures are \textit{computational modes} 
-that will beat least partly damped by the momentum diffusive operator ($i.e.$ the 
-subgrid-scale advection), but not by the resolved advection term. These two schemes
-therefore do not contribute to dump grid point noise in the horizontal velocity field, 
-which results in more noise in vertical velocity field, an undesired feature. This is a well-known 
-characteristics of $C$-grid discretization where $u$ and $v$ are located at different grid point,
-a price to pay to avoid a double averaging on the pressure gradient term as in $B$-grid. 
-To circumvent this, Adcroft (ADD REF HERE) 
-we have proposed to introduce a second velocity ... blahblah.... 
-
-Nevertheless, this technique strongly distort the phase and group velocity of Rossby waves....
-
-A very nice solution to that problem was proposed by \citet{Arakawa_Hsu_MWR90}. The idea is
+that will be at least partly damped by the momentum diffusion operator ($i.e.$ the 
+subgrid-scale advection), but not by the resolved advection term. The ENS and ENE schemes
+therefore do not contribute to any grid point noise in the horizontal velocity field.
+Such noise would result in more noise in the vertical velocity field, an undesirable feature. This is a well-known 
+characteristic of $C$-grid discretization where $u$ and $v$ are located at different grid points,
+a price worth paying to avoid a double averaging in the pressure gradient term as in the $B$-grid. 
+\gmcomment{ To circumvent this, Adcroft (ADD REF HERE) 
+
+Nevertheless, this technique strongly distort the phase and group velocity of Rossby waves....}
+
+A very nice solution to the problem of double averaging was proposed by \citet{Arakawa_Hsu_MWR90}. The idea is
 to get rid of the double averaging by considering triad combinations of vorticity. 
 It is noteworthy that this solution is conceptually quite similar to the one proposed by
-\citep{Griffies_al_JPO98} for the discretization of the iso-neutral diffusive operator.
+\citep{Griffies_al_JPO98} for the discretization of the iso-neutral diffusion operator.
 
 The \citet{Arakawa_Hsu_MWR90} vorticity advection scheme for a single layer is modified 
 for spherical coordinates as described by \citet{Arakawa_Lamb_MWR81} to obtain the EEN scheme. 
-Let first provides the discrete expression of the potential vorticity, $q$, defined at an $f$-point: 
+First consider the discrete expression of the potential vorticity, $q$, defined at an $f$-point: 
 \begin{equation} \label{Eq_pot_vor}
 q  = \frac{\zeta +f} {e_{3f} }
@@ -305,14 +305,14 @@
 %>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 
-Note that a key point in \eqref{Eq_een_e3f} is that the averaging in \textbf{i}- and 
+Note that a key point in \eqref{Eq_een_e3f} is that the averaging in the \textbf{i}- and 
 \textbf{j}- directions uses the masked vertical scale factor but is always divided by 
-$4$, not by the sum of the mask at $T$-point. This preserves the continuity of 
+$4$, not by the sum of the masks at the four $T$-points. This preserves the continuity of 
 $e_{3f}$ when one or more of the neighbouring $e_{3t}$ tends to zero and 
-extends by continuity the value of $e_{3f}$ in the land areas. This feature is essential for 
-$z$-coordinate with partial step.
-
-
-Then, the vorticity triads, $ {^i_j}\mathbb{Q}^{i_p}_{j_p}$ can be defined at $T$-point as 
-the following triad combinations of the neighbouring potential vorticities defined at f-point 
+extends by continuity the value of $e_{3f}$ into the land areas. This feature is essential for 
+the $z$-coordinate with partial steps.
+
+
+Next, the vorticity triads, $ {^i_j}\mathbb{Q}^{i_p}_{j_p}$ can be defined at a $T$-point as 
+the following triad combinations of the neighbouring potential vorticities defined at f-points 
 (Fig.~\ref{Fig_DYN_een_triad}): 
 \begin{equation} \label{Q_triads}
@@ -320,7 +320,7 @@
 = \frac{1}{12} \ \left(   q^{i-i_p}_{j+j_p} + q^{i+j_p}_{j+i_p} + q^{i+i_p}_{j-j_p}  \right)
 \end{equation}
-where the indices $i_p$ and $k_p$ take the following value: $i_p = -1/2$ or $1/2$ and $j_p = -1/2$ or $1/2$. 
-
-The vorticity terms are represented as: 
+where the indices $i_p$ and $k_p$ take the values: $i_p = -1/2$ or $1/2$ and $j_p = -1/2$ or $1/2$. 
+
+Finally, the vorticity terms are represented as: 
 \begin{equation} \label{Eq_dynvor_een}
 \left\{ {
@@ -334,10 +334,10 @@
 \end{equation} 
 
-This EEN scheme in fact combines the conservation properties of ENS and ENE schemes. 
+This EEN scheme in fact combines the conservation properties of the ENS and ENE schemes. 
 It conserves both total energy and potential enstrophy in the limit of horizontally 
 nondivergent flow ($i.e.$ $\chi$=$0$) (see  Appendix~\ref{Apdx_C_vor_zad}). 
-Applied to a realistic ocean configuration, it has been shown that its larger mantis
+Applied to a realistic ocean configuration, it has been shown that it
 leads to a significant reduction of the noise in the vertical velocity field \citep{Le_Sommer_al_OM09}. 
-Furthermore, used in combination with partial step representation of bottom topography,
+Furthermore, used in combination with a partial steps representation of bottom topography,
 it improves the interaction between current and topography, leading to a larger
 topostrophy of the flow  \citep{Barnier_al_OD06, Penduff_al_OS07}. 
@@ -350,5 +350,5 @@
 \label{DYN_keg}
 
-As demonstarted in Appendix~\ref{Apdx_C}, there is a single discrete formulation 
+As demonstrated in Appendix~\ref{Apdx_C}, there is a single discrete formulation 
 of the kinetic energy gradient term that, together with the formulation chosen for 
 the vertical advection (see below), conserves the total kinetic energy:
@@ -492,5 +492,5 @@
 permitted. But the amplitudes of the false extrema are significantly reduced over 
 those in the centred second order method. As the scheme already includes 
-a diffusive component, it can be used without explicit  lateral diffusion on moment 
+a diffusion component, it can be used without explicit  lateral diffusion on momentum 
 ($i.e.$ \np{ln\_dynldf\_lap}=\np{ln\_dynldf\_bilap}=false), and it is recommended to do so.
 
@@ -503,13 +503,13 @@
 For stability reasons,  the first term in (\ref{Eq_dynadv_ubs}), which corresponds 
 to a second order centred scheme, is evaluated using the \textit{now} velocity 
-(centred in time), while the second term, which is the diffusive part of the scheme, 
+(centred in time), while the second term, which is the diffusion part of the scheme, 
 is evaluated using the \textit{before} velocity (forward in time). This is discussed 
 by \citet{Webb_al_JAOT98} in the context of the Quick advection scheme.
 
-Note that the UBS and Quadratic Upstream Interpolation for Convective Kinematics 
-(QUICK) schemes only differ by one coefficient. Substituting $1/6$ with $1/8$ in 
+Note that the UBS and QUICK (Quadratic Upstream Interpolation for Convective Kinematics) 
+schemes only differ by one coefficient. Replacing $1/6$ by $1/8$ in 
 (\ref{Eq_dynadv_ubs}) leads to the QUICK advection scheme \citep{Webb_al_JAOT98}. 
 This option is not available through a namelist parameter, since the $1/6$ coefficient 
-is hard coded. Nevertheless it is quite easy to make the substitution in 
+is hard coded. Nevertheless it is quite easy to make the substitution in the
 \mdl{dynadv\_ubs} module and obtain a QUICK scheme.
 
@@ -610,6 +610,6 @@
 \label{DYN_hpg_sco}
 
-Pressure gradient formulations in $s$-coordinate have been the subject of a vast 
-literature ($e.g.$, \citet{Song1998, Shchepetkin_McWilliams_OM05}). 
+Pressure gradient formulations in an $s$-coordinate have been the subject of a vast 
+number of papers ($e.g.$, \citet{Song1998, Shchepetkin_McWilliams_OM05}). 
 A number of different pressure gradient options are coded, but they are not yet fully 
 documented or tested. 
@@ -656,10 +656,10 @@
 above is the  \textit{now} density, computed from the \textit{now} temperature and 
 salinity. In some specific cases (usually high resolution simulations over an ocean 
-domain which includes weakly stratified regions) the physical phenomenum that 
+domain which includes weakly stratified regions) the physical phenomenon that 
 controls the time-step is internal gravity waves (IGWs). A semi-implicit scheme for 
 doubling the stability limit associated with IGWs can be used \citep{Brown_Campana_MWR78, 
 Maltrud1998}. It involves the evaluation of the hydrostatic pressure gradient as an 
 average over the three time levels $t-\rdt$, $t$, and $t+\rdt$ ($i.e.$  
-\textit{before},  \textit{now} and  \textit{after} time-steps), rather than at central 
+\textit{before},  \textit{now} and  \textit{after} time-steps), rather than at the central 
 time level $t$ only, as in the standard leapfrog scheme. 
 
@@ -723,13 +723,13 @@
 
 The form of the surface pressure gradient term depends on how the user wants to handle 
-the fast external gravity waves that are solution of the analytical equation (\S\ref{PE_hor_pg}). 
-Three formulation are available, all controlled by a CPP key (ln\_dynspg\_xxx):
-a explicit formulation which required a small time step ;
+the fast external gravity waves that are a solution of the analytical equation (\S\ref{PE_hor_pg}). 
+Three formulations are available, all controlled by a CPP key (ln\_dynspg\_xxx):
+an explicit formulation which requires a small time step ;
 a filtered free surface formulation which allows a larger time step by adding a filtering 
-term in the momentum equation ; 
-and a plit-explicit free surface formulation, described below, which also allows a larger time step.
+term into the momentum equation ; 
+and a split-explicit free surface formulation, described below, which also allows a larger time step.
 
 The extra term introduced in the filtered method is calculated 
-implicitly, so that a solver is used to compute it and that the update of the $next$ 
+implicitly, so that a solver is used to compute it. As a consequence the update of the $next$ 
 velocities is done in module \mdl{dynspg\_flt} and not in \mdl{dynnxt}.
 
@@ -743,5 +743,5 @@
 
 In the explicit free surface formulation (\key{dynspg\_exp} defined), the model time step 
-is chosen to be small enough to describe the external gravity waves (typically a few tens of seconds). 
+is chosen to be small enough to resolve the external gravity waves (typically a few tens of seconds). 
 The surface pressure gradient, evaluated using a leap-frog scheme ($i.e.$ centered in time),
 is thus simply given by :
@@ -755,5 +755,5 @@
 Note that in the non-linear free surface case ($i.e.$ \key{vvl} defined), the surface pressure 
 gradient is already included in the momentum tendency  through the level thickness variation 
-when computing the hydrostatic pressure gradient. Thus, nothing is done in the \mdl{dynspg\_exp} module.
+allowed in the computation of the hydrostatic pressure gradient. Thus, nothing is done in the \mdl{dynspg\_exp} module.
 
 %--------------------------------------------------------------------------------------------------------------
@@ -763,9 +763,6 @@
 \label{DYN_spg_ts}
 
-In the split-explicit free surface formulation, also called time-splitting formulation 
-(\key{dynspg\_ts} defined)
-
-
-The split-explicit free surface formulation used in \NEMO follows the one 
+The split-explicit free surface formulation used in \NEMO (\key{dynspg\_ts} defined),
+also called the time-splitting formulation, follows the one 
 proposed by \citet{Griffies_Bk04}. The general idea is to solve the free surface 
 equation and the associated barotropic velocity equations with a smaller time 
@@ -773,5 +770,5 @@
 variables (Fig.\ref {Fig_DYN_dynspg_ts}). 
 The size of the small time step, $\Delta_e$ (the external mode or barotropic time step)
- is provided through \np{nn\_baro} namelist parameter as: 
+ is provided through the \np{nn\_baro} namelist parameter as: 
 $\Delta_e = \Delta / nn\_baro$.
  
@@ -804,5 +801,5 @@
 
 The split-explicit formulation has a damping effect on external gravity waves, 
-which is weaker damping than for the filtered free surface but still significant as 
+which is weaker damping than that for the filtered free surface but still significant, as 
 shown by \citet{Levier2007} in the case of an analytical barotropic Kelvin wave. 
 
@@ -917,6 +914,5 @@
 
 Note that in the linear free surface formulation (\key{vvl} not defined), the ocean depth 
-is time-dependent and so is the matrix to be inverted. It is computed once for all the
-ocean time steps. 
+is time-independent and so is the matrix to be inverted. It is computed once and for all and applies to all ocean time steps. 
 
 % ================================================================
@@ -930,5 +926,5 @@
 %-------------------------------------------------------------------------------------------------------------
 
-The options available for lateral diffusion are for the choice of  laplacian 
+The options available for lateral diffusion are to use either laplacian 
 (rotated or not) or biharmonic operators. The coefficients may be constant 
 or spatially variable; the description of the coefficients is found in the chapter 
@@ -973,10 +969,10 @@
 \label{DYN_ldf_iso}
 
-A rotation of the lateral momentum diffusive operator is needed in several cases: 
-for iso-neutral diffusion in $z$-coordinate (\np{ln\_dynldf\_iso}=true) and for 
+A rotation of the lateral momentum diffusion operator is needed in several cases: 
+for iso-neutral diffusion in the $z$-coordinate (\np{ln\_dynldf\_iso}=true) and for 
 either iso-neutral (\np{ln\_dynldf\_iso}=true) or geopotential 
-(\np{ln\_dynldf\_hor}=true) diffusion in $s$-coordinate. In the partial step 
-case, coordinates are horizontal excepted at the deepest level and no 
-rotation is performed when \np{ln\_dynldf\_hor}=true. The diffusive operator 
+(\np{ln\_dynldf\_hor}=true) diffusion in the $s$-coordinate. In the partial step 
+case, coordinates are horizontal except at the deepest level and no 
+rotation is performed when \np{ln\_dynldf\_hor}=true. The diffusion operator 
 is defined simply as the divergence of down gradient momentum fluxes on each 
 momentum component. It must be emphasized that this formulation ignores 
@@ -1031,5 +1027,5 @@
 \end{equation}
 where $r_1$ and $r_2$ are the slopes between the surface along which the 
-diffusive operator acts and the surface of computation ($z$- or $s$-surfaces). 
+diffusion operator acts and the surface of computation ($z$- or $s$-surfaces). 
 The way these slopes are evaluated is given in the lateral physics chapter 
 (Chap.\ref{LDF}).
@@ -1086,5 +1082,5 @@
 depends on the vertical physics used (see \S\ref{ZDF}).
 
-The surface boundary condition on momentum is given by the stress exerted by 
+The surface boundary condition on momentum is the stress exerted by 
 the wind. At the surface, the momentum fluxes are prescribed as the boundary 
 condition on the vertical turbulent momentum fluxes,
@@ -1114,9 +1110,7 @@
 enter the dynamical equations. 
 
-One is the effect of atmospheric pressure on the ocean dynamics (to be 
-introduced later). 
-
-Another forcing term is the tidal potential, which will be introduced in the 
-reference version soon. 
+One is the effect of atmospheric pressure on the ocean dynamics.
+Another forcing term is the tidal potential.
+Both of which will be introduced into the reference version soon. 
 
 % ================================================================
@@ -1133,10 +1127,10 @@
 The general framework for dynamics time stepping is a leap-frog scheme, 
 $i.e.$ a three level centred time scheme associated with an Asselin time filter 
-(cf. Chap.\ref{STP}). The scheme is applied to the velocity except when using 
-the flux form of momentum advection (cf. \S\ref{DYN_adv_cor_flux}) in variable 
-volume level case (\key{vvl} defined), where it has to be applied to the thickness 
+(cf. Chap.\ref{STP}). The scheme is applied to the velocity, except when using 
+the flux form of momentum advection (cf. \S\ref{DYN_adv_cor_flux}) in the variable 
+volume case (\key{vvl} defined), where it has to be applied to the thickness 
 weighted velocity (see \S\ref{Apdx_A_momentum})  
 
-$\bullet$ vector invariant form or linear free surface (\np{ln\_dynhpg\_vec}=true ; not \key{vvl}):
+$\bullet$ vector invariant form or linear free surface (\np{ln\_dynhpg\_vec}=true ; \key{vvl} not defined):
 \begin{equation} \label{Eq_dynnxt_vec}
 \left\{   \begin{aligned}
@@ -1157,9 +1151,9 @@
 denotes filtered values and $\gamma$ is the Asselin coefficient. $\gamma$ is 
 initialized as \np{nn\_atfp} (namelist parameter). Its default value is \np{nn\_atfp} = $10^{-3}$.
-In both cases, the modified Asselin filter is not applied since a perfect conservation 
-is not an issue for momentum equation.
-
-Note that with the filtered free surface, the update of the \textit{next} velocities 
-is done in the \mdl{dynsp\_flt} module, and only the swap of arrays 
+In both cases, the modified Asselin filter is not applied since perfect conservation 
+is not an issue for the momentum equations.
+
+Note that with the filtered free surface, the update of the \textit{after} velocities 
+is done in the \mdl{dynsp\_flt} module, and only array swapping
 and Asselin filtering is done in \mdl{dynnxt}.
 