Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 2292)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 2293)
@@ -44,9 +44,9 @@
 
    !                                         !!! ** Namelist  namzdf_gls  **
-   LOGICAL  ::   ln_crban   = .FALSE.         ! =T use Craig and Banner scheme
+   LOGICAL  ::   ln_crban      = .FALSE.      ! =T use Craig and Banner scheme
    LOGICAL  ::   ln_length_lim = .FALSE.      ! use limit on the dissipation rate understable stratification (Galperin et al., 1988)
-   LOGICAL  ::   ln_sigpsi = .FALSE.          ! Activate Burchard (2003) modification for k-eps closure AND wave breaking mixing
-   REAL(wp) ::   rn_epsmin  = 1.e-12_wp       ! minimum value of dissipation (m2/s3)
-   REAL(wp) ::   rn_emin    = 1.e-6_wp        ! minimum value of TKE (m2/s2)
+   LOGICAL  ::   ln_sigpsi     = .FALSE.      ! Activate Burchard (2003) modification for k-eps closure AND wave breaking mixing
+   REAL(wp) ::   rn_epsmin     = 1.e-12_wp    ! minimum value of dissipation (m2/s3)
+   REAL(wp) ::   rn_emin       = 1.e-6_wp     ! minimum value of TKE (m2/s2)
    INTEGER  ::   nn_tkebc_surf = 0            ! TKE surface boundary condition (=0/1)
    INTEGER  ::   nn_tkebc_bot  = 0            ! TKE bottom boundary condition (=0/1)
@@ -54,37 +54,37 @@
    INTEGER  ::   nn_psibc_bot  = 0            ! PSI bottom boundary condition (=0/1)
    INTEGER  ::   nn_stab_func  = 0            ! stability functions G88, KC or Canuto (=0/1/2)
-   INTEGER  ::   nn_clos    = 0               ! closure 0/1/2/3 MY82/k-eps/k-w/gen
-   REAL(wp) ::   clim_galp  = 0.53_wp         ! Holt 2008 value for k-eps: 0.267
-   REAL(wp) ::   hsro       = 0.003_wp        ! Minimum surface roughness
-   REAL(wp) ::   rn_charn   = 2.e+5_wp        ! Charnock constant for surface breaking waves mixing : 1400. (standard) or 2.e5 (Stacey value)
-   REAL(wp) ::   rn_crban   = 100._wp         ! Craig and Banner constant for surface breaking waves mixing
-   REAL(wp) ::   rn_cm_sf   = 0.73_wp         ! Shear free turbulence parameters
-   REAL(wp) ::   rn_a_sf    = -2.0_wp         ! Must be negative -2 < rn_a_sf < -1 
-   REAL(wp) ::   rn_l_sf    =  0.2_wp         ! 0 <rn_l_sf<vkarmn    
-   REAL(wp) ::   rn_ghmin   = -0.28
-   REAL(wp) ::   rn_gh0     = 0.0329
-   REAL(wp) ::   rn_ghcri   = 0.03
-   REAL(wp) ::   rn_a1      =  0.92_wp
-   REAL(wp) ::   rn_a2      =  0.74_wp
-   REAL(wp) ::   rn_b1      = 16.60_wp
-   REAL(wp) ::   rn_b2      = 10.10_wp         
-   REAL(wp) ::   rn_e1      =  1.80_wp         
-   REAL(wp) ::   rn_e2      =  1.33_wp         
-   REAL(wp) ::   rn_l1      =  0.107_wp
-   REAL(wp) ::   rn_l2      =  0.0032_wp
-   REAL(wp) ::   rn_l3      =  0.0864_wp
-   REAL(wp) ::   rn_l4      =  0.12_wp
-   REAL(wp) ::   rn_l5      = 11.9_wp
-   REAL(wp) ::   rn_l6      =  0.4_wp
-   REAL(wp) ::   rn_l7      =  0.0_wp
-   REAL(wp) ::   rn_l8      =  0.48_wp
-   REAL(wp) ::   rn_m1      =  0.127_wp
-   REAL(wp) ::   rn_m2      =  0.00336_wp
-   REAL(wp) ::   rn_m3      =  0.0906_wp
-   REAL(wp) ::   rn_m4      =  0.101_wp
-   REAL(wp) ::   rn_m5      = 11.2_wp
-   REAL(wp) ::   rn_m6      =  0.4_wp
-   REAL(wp) ::   rn_m7      =  0.0_wp
-   REAL(wp) ::   rn_m8      =  0.318_wp
+   INTEGER  ::   nn_clos       = 0            ! closure 0/1/2/3 MY82/k-eps/k-w/gen
+   REAL(wp) ::   rn_clim_galp  = 0.53_wp      ! Holt 2008 value for k-eps: 0.267
+   REAL(wp) ::   hsro          = 0.003_wp     ! Minimum surface roughness
+   REAL(wp) ::   rn_charn      = 2.e+5_wp     ! Charnock constant for surface breaking waves mixing : 1400. (standard) or 2.e5 (Stacey value)
+   REAL(wp) ::   rn_crban      = 100._wp      ! Craig and Banner constant for surface breaking waves mixing
+   REAL(wp) ::   rn_cm_sf      = 0.73_wp      ! Shear free turbulence parameters
+   REAL(wp) ::   rn_a_sf       = -2.0_wp      ! Must be negative -2 < rn_a_sf < -1 
+   REAL(wp) ::   rn_l_sf       =  0.2_wp      ! 0 <rn_l_sf<vkarmn    
+   REAL(wp) ::   rn_ghmin      = -0.28
+   REAL(wp) ::   rn_gh0        = 0.0329
+   REAL(wp) ::   rn_ghcri      = 0.03
+   REAL(wp) ::   rn_a1         =  0.92_wp
+   REAL(wp) ::   rn_a2         =  0.74_wp
+   REAL(wp) ::   rn_b1         = 16.60_wp
+   REAL(wp) ::   rn_b2         = 10.10_wp         
+   REAL(wp) ::   rn_e1         =  1.80_wp         
+   REAL(wp) ::   rn_e2         =  1.33_wp         
+   REAL(wp) ::   rn_l1         =  0.107_wp
+   REAL(wp) ::   rn_l2         =  0.0032_wp
+   REAL(wp) ::   rn_l3         =  0.0864_wp
+   REAL(wp) ::   rn_l4         =  0.12_wp
+   REAL(wp) ::   rn_l5         = 11.9_wp
+   REAL(wp) ::   rn_l6         =  0.4_wp
+   REAL(wp) ::   rn_l7         =  0.0_wp
+   REAL(wp) ::   rn_l8         =  0.48_wp
+   REAL(wp) ::   rn_m1         =  0.127_wp
+   REAL(wp) ::   rn_m2         =  0.00336_wp
+   REAL(wp) ::   rn_m3         =  0.0906_wp
+   REAL(wp) ::   rn_m4         =  0.101_wp
+   REAL(wp) ::   rn_m5         = 11.2_wp
+   REAL(wp) ::   rn_m6         =  0.4_wp
+   REAL(wp) ::   rn_m7         =  0.0_wp
+   REAL(wp) ::   rn_m8         =  0.318_wp
    REAL(wp) ::   rn_c02
    REAL(wp) ::   rn_c02r
@@ -781,5 +781,5 @@
                ! Galperin criterium (NOTE : Not required if the proper value of C3 in stable cases is calculated) 
                zrn2 = MAX( rn2(ji,jj,jk), rsmall )
-               mxln(ji,jj,jk) = MIN( clim_galp*SQRT( 2.*en(ji,jj,jk)/zrn2 ), mxln(ji,jj,jk) )
+               mxln(ji,jj,jk) = MIN( rn_clim_galp*SQRT( 2.*en(ji,jj,jk)/zrn2 ), mxln(ji,jj,jk) )
             END DO
          END DO
@@ -933,8 +933,8 @@
       !!
       NAMELIST/namzdf_gls/rn_emin, rn_epsmin, ln_length_lim, &
-         &            clim_galp, ln_crban, ln_sigpsi,    &
-         &            rn_crban, rn_charn,                &
-         &            nn_tkebc_surf, nn_tkebc_bot,       &
-         &            nn_psibc_surf, nn_psibc_bot,       &
+         &            rn_clim_galp, ln_crban, ln_sigpsi,     &
+         &            rn_crban, rn_charn,                    &
+         &            nn_tkebc_surf, nn_tkebc_bot,           &
+         &            nn_psibc_surf, nn_psibc_bot,           &
          &            nn_stab_func, nn_clos
       !!----------------------------------------------------------
@@ -958,5 +958,5 @@
          WRITE(numout,*) '             Bottom roughness (m)                        rn_hbro = ', rn_hbro
          WRITE(numout,*) '             Limit dissipation rate under stable stratification ln_length_lim = ',ln_length_lim
-         WRITE(numout,*) '             Galperin length scale limitation coef (Standard: 0.53, Holt: 0.26) clim_galp = ', clim_galp
+         WRITE(numout,*) '             Galperin length scale limitation coef (Standard: 0.53, Holt: 0.26) rn_clim_galp = ', rn_clim_galp
          WRITE(numout,*) '             TKE Surface boundary condition       nn_tkebc_surf = ', nn_tkebc_surf
          WRITE(numout,*) '             TKE Bottom boundary condition        nn_tkebc_bot  = ', nn_tkebc_bot
@@ -1206,5 +1206,5 @@
       rn_c03  = rn_c0**3._wp
       rn_c04  = rn_c0**4._wp
-      rn_c03_sqrt2_galp = rn_c03 / SQRT(2._wp) / clim_galp
+      rn_c03_sqrt2_galp = rn_c03 / SQRT(2._wp) / rn_clim_galp
       rn_sbc_mb   = 0.5 * (15.8*rn_crban)**(2./3.) ! Surf. bound. cond. from Mellor and Blumberg
       rn_sbc_std  = 3.75                           ! Surf. bound. cond. standard (prod=diss)